version: '3.1'

services:
  nginx:
    build:
      context: .
      dockerfile: ./docker/nginx/Dockerfile
    container_name: nginx
    restart: always
    networks:
      front:
        ipv4_address: 172.10.10.2
    ports:
      - ${LISTEN_PORT}:80
    environment:
      - LISTEN_PORT=${LISTEN_PORT}
    volumes:
      - ./:/app
      - ./storage/logs/nginx:/var/log/nginx
      - ./docker/nginx/config/nginx.conf:/etc/nginx/nginx.conf
      - ./docker/nginx/config/templates/sites.tmpl:/etc/nginx/conf.d/sites.tmpl
    command: /bin/bash -c "envsubst \"`for v in $$(compgen -v);do printf '$${%s} ' $$v;done`'\" < /etc/nginx/conf.d/sites.tmpl > /etc/nginx/conf.d/sites.conf && nginx -g 'daemon off;'"
    depends_on:
      - app
      - mysql
  app:
    build:
      context: .
      dockerfile: ./docker/php_fpm/Dockerfile
    container_name: app
    restart: always
    networks:
      front:
        ipv4_address: 172.10.10.3
    volumes:
      - ./:/app
      - ./docker/php_fpm/config/php.ini:/usr/local/etc/php/conf.d/custom_php.ini
      - ./docker/php_fpm/config/crontasks:/etc/cron.d/crontasks
    links:
      - mysql
  mysql:
    build:
      context: .
      dockerfile: ./docker/mysql/Dockerfile
    container_name: mysql
    environment:
      MYSQL_ROOT_PASSWORD: ${MYSQL_ROOT_PASSWORD}
    networks:
      front:
        ipv4_address: 172.10.10.4
    ports:
      - 3306:3306
    volumes:
      - ${MYSQL_DATA_FOLDER}:/var/lib/mysql:rw
      - ${LOG_DIR}/mysql:/var/log/mysql:rw
      - ./docker/mysql/config/custom-config.cnf:/etc/mysql/conf.d/custom-config.cnf
      - ./docker/mysql/config/init.sql:/docker-entrypoint-initdb.d/init.sql
    command: mysqld --init-file="/docker-entrypoint-initdb.d/init.sql"
networks:
  front:
    driver: bridge
    driver_opts:
      com.docker.network.enable_ipv6: "false"
    ipam:
      driver: default
      config:
        - subnet: 172.10.10.0/24